/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.impl.sql

import metridoc.sql.DDLHandler
import metridoc.utils.Assert

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 9/2/11
 * Time: 11:23 AM
 * this class is still in progress, do not use
 */
abstract class DefaultDDLHandler implements DDLHandler{

    public static final String TAB = "    "



    String getTypeDescription(String name, int type, Integer length, data) {
        return "${TAB}${name} ${getColumnType(type, length)}"
    }

    protected abstract String getCreateStatementFromBatch(List<Map> batch)

    protected abstract String getColumnType(int type, Integer length)

    static Map<String, Map> getColumns(ConfigObject configObject) {
        Assert.isTrue(configObject.loading instanceof Map, "the passed configuration must contain a loading variable that is of type Map")
        Assert.isTrue(!configObject.loading.isEmpty(), "the passed configuration must contain a loading variable")
        validateColumns(configObject.loading)

        return configObject.loading
    }

    static void validateColumns(Map columns) {
         columns.each {key, Map value ->
            String message = "each column must have a type, and type must be a String"
            Assert.isTrue(value.containsKey("type"), message)
            Assert.isTrue(value.type instanceof String, message)
        }
    }

    static void validateConfig(ConfigObject config) {
        def columns = getColumns(config)

        validateColumns(columns)
    }
    abstract protected String getLoadingCreateStatement(ConfigObject configObject)

}
