/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.impl.sql

import metridoc.sql.DDLHandler
import java.sql.Types
import metridoc.sql.IllegalConversionException
import metridoc.utils.Assert
import metridoc.utils.SystemUtils
import metridoc.utils.SqlUtils

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 9/2/11
 * Time: 11:20 AM
 * To change this template use File | Settings | File Templates.
 *
 * This class is still in progress, do not use
 */
class MySqlDDLHandler extends DefaultDDLHandler {

    @Override
    String getCreateStatementFromBatch(List<Map> batch) {

    }

    @Override
    protected String getColumnType(int type, Integer length) {

        switch(type) {
            case Types.BOOLEAN:
                return "tinyint"
            case Types.DATE:
                return "date"
            case Types.VARCHAR:
                int varcharLength = length ? length : 255
                return "varchar(${varcharLength})"
            case Types.TIMESTAMP:
                return "datetime"
            case Types.INTEGER:
                return "int"
            case Types.BIGINT:
                return "bigint"
            case Types.DOUBLE:
                return "double"
            default:
                throw new IllegalConversionException("Could not convert ${type} into a type")
        }
        

    }

    @Override
    void createTables(ConfigObject configObject) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
    void createLoadingTable(ConfigObject configObject) {
        String name = configObject.name
        StringBuilder builder = new StringBuilder()

        builder.append("create table ${name} (${SystemUtils.LINE_SEPARATOR}")
        builder.append()
    }

    @Override
    protected String getLoadingCreateStatement(ConfigObject configObject) {

    }
}
